#ifndef	ENCODER_H
#define	ENCODER_H


#define EncoderPort      PORTB 
#define EncoderPortDDR   DDRB
#define enc_pin1         PINB3
#define enc_pin2         PINB4
#define EncoderPinPort   PINB


//#define RIGHT_SPIN 0x01 
//#define LEFT_SPIN 0xff

#include <avr/io.h>


void PollEncoder(void);


#define ENCODER_MASK ((1<<enc_pin1)|(1<<enc_pin2))

unsigned char EncState = 0; //  
unsigned char New = 0; //  
volatile signed char bufEnc; // 



void PollEncoder()
{

New  =((EncoderPinPort>>3) & 0b11);
EncState = (New << 2) | EncState;

switch(EncState)

{
case 0b00000001:
case 0b00000111:
case 0b00001110:
case 0b00001000:
bufEnc++;
break;


case 0b00000010:
case 0b00001011:
case 0b00001101:
case 0b00000100:
bufEnc--;
break;
}
EncState = New;
   
}

#endif  //encoder_h
