#ifndef	ingic_h
#define	indic_h

void measure(void);

void k4094_init (volatile unsigned char);

/*****************************************************

Chip type               : ATmega168
Program type            : Application
AVR Core Clock frequency: 8,000000 MHz
Memory model            : Small
External RAM size       : 0
Data Stack size         : 256
   UR3QQW    SI5351A.   Si5351QRP_Lab.
        .            ADC.
     CD4094.
*****************************************************/



//#include <avr/io.h>
//#include <avr/interrupt.h>
//#include <avr/sfr_defs.h>
//#include <stdio.h>

//#include <util/delay.h>

//#include "main.h"

#define StartConvAdc() ADCSRA |= (1<<ADSC)
#define StopConvAdc()   ADCSRA &=~(_BV(ADSC))  

volatile unsigned int AdcBuf;
volatile unsigned char l_1;

 /***********************     ************************/
 void measure()
 {
  AdcBuf=0;
  ADMUX = (0<<REFS1)|(1<<REFS0)|(0<<ADLAR)|(0<<MUX3)|(1<<MUX2)|(1<<MUX1)|(1<<MUX0);
 
  StartConvAdc();                                        //  .
   _delay_ms(1);                                      //     
   
    AdcBuf = ADCL;                                 //   
    
    AdcBuf = (ADCH<<8)|AdcBuf;                      //  
    
 
	
  if      (AdcBuf < 50)  l_1=0b00000000;	
  else if (AdcBuf < 100)   l_1=0b00000001;
  else if (AdcBuf < 200)    l_1=0b00000011;
  else if (AdcBuf < 350)     l_1=0b00000111;
  else if (AdcBuf < 500)      l_1=0b00001111;
  else if (AdcBuf < 650)       l_1=0b00011111;
  else if (AdcBuf < 850)        l_1=0b00111111;
  else if (AdcBuf < 950)         l_1=0b01111111;
  else                            l_1=0b11111111;	 
  StopConvAdc();
 } 
  
 /***************   **************/
  
 void k4094_init(volatile unsigned char y)
 {
 
unsigned char i; 
unsigned char tmp;

tmp = y;                        

for (i = 0; i < 8; i++)
 { 
if (tmp & 0x01) 
PORTC |=_BV(PC2);
else   PORTC &=~(_BV(PC2));
_delay_ms(1);                                      // 

PORTC |=_BV(PC3);                                  // 
_delay_ms(1);                                      // 

PORTC &=~(_BV(PC3)); 
tmp >>= 1;                                        //    

   } 
   PORTC |=_BV(PC1);
   _delay_ms(1);
   PORTC &=~(_BV(PC1));  //  
    
_delay_ms(1);     
}  
 
/************    *******************/                
void progress(void)
{

measure();

k4094_init(l_1);                  //  

}



#endif  
